diff --git a/binaries/data/mods/public/globalscripts/Resources.js b/binaries/data/mods/public/globalscripts/Resources.js
new file mode 100644
index 0000000..04c3056
--- /dev/null
+++ b/binaries/data/mods/public/globalscripts/Resources.js
@@ -0,0 +1,164 @@
+
+/**
+ * Resources Global
+ *
+ * Engine.FindJSONFiles only exists within the session context
+ * Engine.BuildDirEntList only exists within the gui context
+ * The AI and test contexts have no access to any JSON file access functions
+ */
+function Resources()
+{
+	let jsonFiles = [];
+	if (Engine.FindJSONFiles)
+	{
+		jsonFiles = Engine.FindJSONFiles("resources", false);
+		for (let file in jsonFiles)
+			jsonFiles[file] = "resources/" + jsonFiles[file] + ".json";
+	}
+	else if (Engine.BuildDirEntList)
+		jsonFiles = Engine.BuildDirEntList("simulation/data/resources/", "*.json", false);
+	else
+	{
+		warn("Resources: No JSON access functions are unavailable");
+		return;
+	}
+
+	this.resourceData = [];
+	this.resourceCodes = [];
+
+	for (let filename of jsonFiles)
+	{
+		let data = Engine.ReadJSONFile(filename);
+		if (!data)
+			continue;
+
+		data.subtypeNames = data.subtypes;
+		data.subtypes = Object.keys(data.subtypes);
+
+		this.resourceData.push(data);
+		if (data.enabled)
+			this.resourceCodes.push(data.code);
+	}
+};
+
+Resources.prototype.GetData = function()
+{
+	return this.resourceData.filter(resource => resource.enabled);
+};
+
+Resources.prototype.GetResource = function(type)
+{
+	let lType = type.toLowerCase();
+	return this.GetData().find(resource => resource.code == lType);
+};
+
+Resources.prototype.GetCodes = function()
+{
+	return this.resourceCodes;
+};
+
+/**
+ * Returns an object containing untranslated resource names mapped to
+ * resource codes. Includes subtypes.
+ */
+Resources.prototype.GetNames = function()
+{
+	let names = {};
+	for (let res of this.GetData())
+	{
+		names[res.code] = res.name;
+		for (let subres of res.subtypes)
+			names[subres] = res.subtypeNames[subres]
+	}
+	return names;
+};
+
+/**
+ * Builds a RelaxRNG schema based on currently valid elements.
+ *
+ * To prevent validation errors, disabled resources are included in the schema.
+ *
+ * @param datatype The datatype of the element
+ * @param additional Array of additional data elements. Time, xp, treasure, etc.
+ * @param subtypes If true, resource subtypes will be included as well.
+ * @return RelaxNG schema string
+ */
+Resources.prototype.BuildSchema = function(datatype, additional = [], subtypes = false)
+{
+	if (!datatype)
+		return "";
+
+	switch (datatype)
+	{
+	case "decimal":
+	case "nonNegativeDecimal":
+	case "positiveDecimal":
+		datatype = "<ref name='" + datatype + "'/>";
+		break;
+
+	default:
+		datatype = "<data type='" + datatype + "'/>";
+	}
+
+	let resCodes = this.resourceData.map(resource => resource.code);
+	let schema = "<interleave>";
+	for (let res of resCodes.concat(additional))
+		schema +=
+			"<optional>" +
+				"<element name='" + res + "'>" +
+					datatype +
+				"</element>" +
+			"</optional>";
+
+	if (!subtypes)
+		return schema + "</interleave>";
+
+	for (let res of this.resourceData)
+		for (let subtype of res.subtypes)
+			schema +=
+				"<optional>" +
+					"<element name='" + res.code + "." + subtype + "'>" +
+						datatype +
+					"</element>" +
+				"</optional>";
+
+	if (additional.indexOf("treasure") !== -1)
+		for (let res of resCodes)
+			schema +=
+				"<optional>" +
+					"<element name='" + "treasure." + res + "'>" +
+						datatype +
+					"</element>" +
+				"</optional>";
+
+	return schema + "</interleave>";
+}
+
+/**
+ * Builds the value choices for a RelaxNG `<choice></choice>` object, based on currently valid resources.
+ *
+ * @oaram subtypes If set to true, the choices returned will be resource subtypes, rather than main types
+ * @param treasure If set to true, the pseudo resource 'treasure' (or its subtypes) will be included
+ * @return String of RelaxNG Schema `<choice/>` values.
+ */
+Resources.prototype.BuildChoicesSchema = function(subtypes = false, treasure = false)
+{
+	let schema = "<choice>";
+
+	if (!subtypes)
+	{
+		let resCodes = this.resourceData.map(resource => resource.code);
+		for (let res of resCodes.concat(treasure ? [ "treasure" ] : []))
+			schema += "<value>" + res + "</value>";
+	}
+	else
+		for (let res of this.resourceData)
+		{
+			for (let subtype of res.subtypes)
+				schema += "<value>" + res.code + "." + subtype + "</value>";
+			if (treasure)
+				schema += "<value>" + "treasure." + res.code + "</value>";
+		}
+
+	return schema + "</choice>";
+}
diff --git a/binaries/data/mods/public/gui/common/functions_utility.js b/binaries/data/mods/public/gui/common/functions_utility.js
index 9984cb0..9e89efd 100644
--- a/binaries/data/mods/public/gui/common/functions_utility.js
+++ b/binaries/data/mods/public/gui/common/functions_utility.js
@@ -416,3 +416,45 @@ function formatPlayerInfo(playerDataArray, playerStates)
 
 	return teamDescription.join("\n\n");
 }
+
+/**
+ * Horizontally fit objects within a parent.
+ *
+ * @param margin - The gap, in px, between the repeated objects
+ * @param limit - The number of elements to fit
+ */
+function horizontallyDistributeObjects(parentName, margin = 0, limit = undefined)
+{
+	let objects = Engine.GetGUIObjectByName(parentName).children;
+	if (limit !== undefined)
+		objects = objects.splice(0, limit);
+
+	for (let i in objects)
+	{
+		i = +i;
+		let size = objects[i].size;
+		size.rleft = 100 / objects.length * i;
+		size.rright = 100 / objects.length * (i + 1);
+		size.right = -margin;
+		objects[i].size = size;
+	}
+}
+
+/**
+ * Hide all children after a certain index
+ *
+ * @param prefix - The part of the element name preceeding the index
+ * @param idx - The index from which to start
+ * @param prefix - The part of the element name after the index
+ */
+function hideRemaining(prefix, idx, suffix)
+{
+	while (true)
+	{
+		let obj = Engine.GetGUIObjectByName(prefix + idx + suffix);
+		if (!obj)
+			return;
+		obj.hidden = true;
+		++idx;
+	}
+}
diff --git a/binaries/data/mods/public/gui/common/l10n.js b/binaries/data/mods/public/gui/common/l10n.js
index 53c16c2..3fd4570 100644
--- a/binaries/data/mods/public/gui/common/l10n.js
+++ b/binaries/data/mods/public/gui/common/l10n.js
@@ -1,75 +1,7 @@
-const localisedResourceNames = {
-	"firstWord": {
-		// Translation: Word as used at the beginning of a sentence or as a single-word sentence.
-		"food": translateWithContext("firstWord", "Food"),
-		// Translation: Word as used at the beginning of a sentence or as a single-word sentence.
-		"meat": translateWithContext("firstWord", "Meat"),
-		// Translation: Word as used at the beginning of a sentence or as a single-word sentence.
-		"metal": translateWithContext("firstWord", "Metal"),
-		// Translation: Word as used at the beginning of a sentence or as a single-word sentence.
-		"ore": translateWithContext("firstWord", "Ore"),
-		// Translation: Word as used at the beginning of a sentence or as a single-word sentence.
-		"rock": translateWithContext("firstWord", "Rock"),
-		// Translation: Word as used at the beginning of a sentence or as a single-word sentence.
-		"ruins": translateWithContext("firstWord", "Ruins"),
-		// Translation: Word as used at the beginning of a sentence or as a single-word sentence.
-		"stone": translateWithContext("firstWord", "Stone"),
-		// Translation: Word as used at the beginning of a sentence or as a single-word sentence.
-		"treasure": translateWithContext("firstWord", "Treasure"),
-		// Translation: Word as used at the beginning of a sentence or as a single-word sentence.
-		"tree": translateWithContext("firstWord", "Tree"),
-		// Translation: Word as used at the beginning of a sentence or as a single-word sentence.
-		"wood": translateWithContext("firstWord", "Wood"),
-		// Translation: Word as used at the beginning of a sentence or as a single-word sentence.
-		"fruit": translateWithContext("firstWord", "Fruit"),
-		// Translation: Word as used at the beginning of a sentence or as a single-word sentence.
-		"grain": translateWithContext("firstWord", "Grain"),
-		// Translation: Word as used at the beginning of a sentence or as a single-word sentence.
-		"fish": translateWithContext("firstWord", "Fish"),
-	},
-	"withinSentence": {
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"food": translateWithContext("withinSentence", "Food"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"meat": translateWithContext("withinSentence", "Meat"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"metal": translateWithContext("withinSentence", "Metal"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"ore": translateWithContext("withinSentence", "Ore"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"rock": translateWithContext("withinSentence", "Rock"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"ruins": translateWithContext("withinSentence", "Ruins"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"stone": translateWithContext("withinSentence", "Stone"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"treasure": translateWithContext("withinSentence", "Treasure"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"tree": translateWithContext("withinSentence", "Tree"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"wood": translateWithContext("withinSentence", "Wood"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"fruit": translateWithContext("withinSentence", "Fruit"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"grain": translateWithContext("withinSentence", "Grain"),
-		// Translation: Word as used in the middle of a sentence (which may require using lowercase for your language).
-		"fish": translateWithContext("withinSentence", "Fish"),
-	}
-};
 
-function getLocalizedResourceName(resourceCode, context)
+function getLocalizedResourceName(resourceName, context)
 {
-	if (!localisedResourceNames[context])
-	{
-		warn("Internationalization: Unexpected context for resource type localization found: ‘" + context + "’. This context is not supported.");
-		return resourceCode;
-	}
-	if (!localisedResourceNames[context][resourceCode])
-	{
-		warn("Internationalization: Unexpected resource type found with code ‘" + resourceCode + ". This resource type must be internationalized.");
-		return resourceCode;
-	}
-	return localisedResourceNames[context][resourceCode];
+	return translateWithContext(context, resourceName);
 }
 
 /**
@@ -81,7 +13,7 @@ function getLocalizedResourceAmounts(resources)
 		.filter(type => resources[type] > 0)
 		.map(type => sprintf(translate("%(amount)s %(resourceType)s"), {
 			"amount": resources[type],
-			"resourceType": getLocalizedResourceName(type, "withinSentence")
+			"resourceType": translateWithContext("withinSentence", type)
 		}));
 
 	if (amounts.length > 1)
diff --git a/binaries/data/mods/public/gui/session/menu.js b/binaries/data/mods/public/gui/session/menu.js
index 494bd14..99bfd5e 100644
--- a/binaries/data/mods/public/gui/session/menu.js
+++ b/binaries/data/mods/public/gui/session/menu.js
@@ -22,9 +22,6 @@ const INITIAL_MENU_POSITION = "100%-164 " + MENU_TOP + " 100% " + MENU_BOTTOM;
 // Number of pixels per millisecond to move
 const MENU_SPEED = 1.2;
 
-// Available resources in trade and tribute menu
-const RESOURCES = ["food", "wood", "stone", "metal"];
-
 // Trade menu: step for probability changes
 const STEP = 5;
 
@@ -237,6 +234,7 @@ function openDiplomacy()
 	g_IsDiplomacyOpen = true;
 
 	let isCeasefireActive = GetSimState().ceasefireActive;
+	let resCodes = g_ResourceData.GetCodes();
 
 	// Get offset for one line
 	let onesize = Engine.GetGUIObjectByName("diplomacyPlayer[0]").size;
@@ -255,7 +253,13 @@ function openDiplomacy()
 		diplomacyFormatAttackRequestButton(i, myself || playerInactive || isCeasefireActive || !hasAllies || !g_Players[i].isEnemy[g_ViewedPlayer]);
 	}
 
-	Engine.GetGUIObjectByName("diplomacyDialogPanel").hidden = false;
+	let dialog = Engine.GetGUIObjectByName("diplomacyDialogPanel");
+	let size = dialog.size;
+	let width = 260 + resCodes.length * 10;
+	size.left = -width;
+	size.right = width;
+	dialog.size = size;
+	dialog.hidden = false;
 }
 
 function diplomacySetupTexts(i, rowsize)
@@ -305,16 +309,22 @@ function diplomacyFormatStanceButtons(i, hidden)
 
 function diplomacyFormatTributeButtons(i, hidden)
 {
-	for (let resource of RESOURCES)
+	let resNames = g_ResourceData.GetNames();
+	let resCodes = g_ResourceData.GetCodes();
+	let r = 0;
+	for (let resCode of resCodes)
 	{
-		let button = Engine.GetGUIObjectByName("diplomacyPlayerTribute"+resource[0].toUpperCase()+resource.substring(1)+"["+(i-1)+"]");
+		let button = Engine.GetGUIObjectByName("diplomacyPlayer["+(i-1)+"]_tribute["+r+"]");
+		Engine.GetGUIObjectByName("diplomacyPlayer["+(i-1)+"]_tribute["+r+"]_image").sprite = "stretched:session/icons/resources/"+resCode+".png";
 		button.hidden = hidden;
+		setPanelObjectPosition(button, r, 8, 0);
+		++r;
 		if (hidden)
 			continue;
 
 		button.enabled = controlsPlayer(g_ViewedPlayer);
-		button.tooltip = formatTributeTooltip(i, resource, 100);
-		button.onpress = (function(i, resource, button) {
+		button.tooltip = formatTributeTooltip(i, resNames[resCode], 100);
+		button.onpress = (function(i, resCode, button) {
 			// Shift+click to send 500, shift+click+click to send 1000, etc.
 			// See INPUT_MASSTRIBUTING in input.js
 			let multiplier = 1;
@@ -327,24 +337,24 @@ function diplomacyFormatTributeButtons(i, hidden)
 				}
 
 				let amounts = {};
-				for (let type of RESOURCES)
-					amounts[type] = 0;
-				amounts[resource] = 100 * multiplier;
+				for (let res of resCodes)
+					amounts[res] = 0;
+				amounts[resCode] = 100 * multiplier,
 
-				button.tooltip = formatTributeTooltip(i, resource, amounts[resource]);
+				button.tooltip = formatTributeTooltip(i, resNames[resCode], amounts[resCode]);
 
 				// This is in a closure so that we have access to `player`, `amounts`, and `multiplier` without some
 				// evil global variable hackery.
 				g_FlushTributing = function() {
 					Engine.PostNetworkCommand({ "type": "tribute", "player": i, "amounts":  amounts });
 					multiplier = 1;
-					button.tooltip = formatTributeTooltip(i, resource, 100);
+					button.tooltip = formatTributeTooltip(i, resNames[resCode], 100);
 				};
 
 				if (!isBatchTrainPressed)
 					g_FlushTributing();
 			};
-		})(i, resource, button);
+		})(i, resCode, button);
 	}
 }
 
@@ -398,37 +408,33 @@ function openTrade()
 		}
 	};
 
-	var proba = Engine.GuiInterfaceCall("GetTradingGoods", g_ViewedPlayer);
-	var button = {};
-	var selec = RESOURCES[0];
-	for (var i = 0; i < RESOURCES.length; ++i)
+	let proba = Engine.GuiInterfaceCall("GetTradingGoods", g_ViewedPlayer);
+	let button = {};
+	let resCodes = g_ResourceData.GetCodes();
+	let selec = resCodes[0];
+	hideRemaining("tradeResource[", resCodes.length, "]");
+
+	for (let i = 0; i < resCodes.length; ++i)
 	{
-		var buttonResource = Engine.GetGUIObjectByName("tradeResource["+i+"]");
-		if (i > 0)
-		{
-			var size = Engine.GetGUIObjectByName("tradeResource["+(i-1)+"]").size;
-			var width = size.right - size.left;
-			size.left += width;
-			size.right += width;
-			Engine.GetGUIObjectByName("tradeResource["+i+"]").size = size;
-		}
-		var resource = RESOURCES[i];
-		proba[resource] = (proba[resource] ? proba[resource] : 0);
-		var buttonResource = Engine.GetGUIObjectByName("tradeResourceButton["+i+"]");
-		var icon = Engine.GetGUIObjectByName("tradeResourceIcon["+i+"]");
-		icon.sprite = "stretched:session/icons/resources/" + resource + ".png";
-		var label = Engine.GetGUIObjectByName("tradeResourceText["+i+"]");
-		var buttonUp = Engine.GetGUIObjectByName("tradeArrowUp["+i+"]");
-		var buttonDn = Engine.GetGUIObjectByName("tradeArrowDn["+i+"]");
-		var iconSel = Engine.GetGUIObjectByName("tradeResourceSelection["+i+"]");
-		button[resource] = { "up": buttonUp, "dn": buttonDn, "label": label, "sel": iconSel };
+		let buttonResource = Engine.GetGUIObjectByName("tradeResource["+i+"]");
+		setPanelObjectPosition(buttonResource, i, 8);
+		let resCode = resCodes[i];
+		proba[resCode] = (proba[resCode] ? proba[resCode] : 0);
+		buttonResource = Engine.GetGUIObjectByName("tradeResourceButton["+i+"]");
+		let icon = Engine.GetGUIObjectByName("tradeResourceIcon["+i+"]");
+		icon.sprite = "stretched:session/icons/resources/" + resCode + ".png";
+		let label = Engine.GetGUIObjectByName("tradeResourceText["+i+"]");
+		let buttonUp = Engine.GetGUIObjectByName("tradeArrowUp["+i+"]");
+		let buttonDn = Engine.GetGUIObjectByName("tradeArrowDn["+i+"]");
+		let iconSel = Engine.GetGUIObjectByName("tradeResourceSelection["+i+"]");
+		button[resCode] = { "up": buttonUp, "dn": buttonDn, "label": label, "sel": iconSel };
 
 		buttonResource.enabled = controlsPlayer(g_ViewedPlayer);
 		buttonResource.onpress = (function(resource){
 			return function() {
 				if (Engine.HotkeyIsPressed("session.fulltradeswap"))
 				{
-					for (var ress of RESOURCES)
+					for (let ress of resCodes)
 						proba[ress] = 0;
 					proba[resource] = 100;
 					Engine.PostNetworkCommand({"type": "set-trading-goods", "tradingGoods": proba});
@@ -436,7 +442,7 @@ function openTrade()
 				selec = resource;
 				updateButtons();
 			};
-		})(resource);
+		})(resCode);
 
 		buttonUp.enabled = controlsPlayer(g_ViewedPlayer);
 		buttonUp.onpress = (function(resource){
@@ -446,7 +452,7 @@ function openTrade()
 				Engine.PostNetworkCommand({"type": "set-trading-goods", "tradingGoods": proba});
 				updateButtons();
 			};
-		})(resource);
+		})(resCode);
 
 		buttonDn.enabled = controlsPlayer(g_ViewedPlayer);
 		buttonDn.onpress = (function(resource){
@@ -456,7 +462,7 @@ function openTrade()
 				Engine.PostNetworkCommand({"type": "set-trading-goods", "tradingGoods": proba});
 				updateButtons();
 			};
-		})(resource);
+		})(resCode);
 	}
 	updateButtons();
 
@@ -464,7 +470,13 @@ function openTrade()
 	Engine.GetGUIObjectByName("landTraders").caption = getIdleLandTradersText(traderNumber);
 	Engine.GetGUIObjectByName("shipTraders").caption = getIdleShipTradersText(traderNumber);
 
-	Engine.GetGUIObjectByName("tradeDialogPanel").hidden = false;
+	let dialog = Engine.GetGUIObjectByName("tradeDialogPanel");
+	let size = dialog.size;
+	let wid = resCodes.length * (58/2);
+	size.left = -(134 + wid);
+	size.right = (134 + wid);
+	dialog.size = size;
+	dialog.hidden = false;
 }
 
 function getIdleLandTradersText(traderNumber)
diff --git a/binaries/data/mods/public/gui/session/selection_details.js b/binaries/data/mods/public/gui/session/selection_details.js
index 29acc09..36fa2a6 100644
--- a/binaries/data/mods/public/gui/session/selection_details.js
+++ b/binaries/data/mods/public/gui/session/selection_details.js
@@ -13,10 +13,8 @@ function layoutSelectionMultiple()
 function getResourceTypeDisplayName(resourceType)
 {
 	let resourceCode = resourceType.generic;
-	if (resourceCode == "treasure")
-		return getLocalizedResourceName(resourceType.specific, "firstWord");
-	else
-		return getLocalizedResourceName(resourceCode, "firstWord");
+	let resourceName = g_ResourceData.GetNames()[(resourceCode == "treasure" ? resourceType.specific : resourceCode)]
+	return getLocalizedResourceName(resourceName, "firstWord");
 }
 
 // Updates the health bar of garrisoned units
diff --git a/binaries/data/mods/public/gui/session/selection_panels.js b/binaries/data/mods/public/gui/session/selection_panels.js
index c21fc4f..ceae7a9 100644
--- a/binaries/data/mods/public/gui/session/selection_panels.js
+++ b/binaries/data/mods/public/gui/session/selection_panels.js
@@ -34,6 +34,8 @@ let g_FormationsInfo = new Map();
 
 let g_SelectionPanels = {};
 
+let g_BarterSell;
+
 g_SelectionPanels.Alert = {
 	"getMaxNumberOfItems": function()
 	{
@@ -87,15 +89,14 @@ g_SelectionPanels.Alert = {
 g_SelectionPanels.Barter = {
 	"getMaxNumberOfItems": function()
 	{
-		return 4;
+		return 8;
 	},
 	"rowLength": 4,
 	"getItems": function(unitEntState, selection)
 	{
 		if (!unitEntState.barterMarket)
 			return [];
-		// ["food", "wood", "stone", "metal"]
-		return BARTER_RESOURCES;
+		return g_ResourceData.GetCodes();
 	},
 	"setupButton": function(data)
 	{
@@ -115,11 +116,14 @@ g_SelectionPanels.Barter = {
 		if (Engine.HotkeyIsPressed("session.massbarter"))
 			amountToSell *= BARTER_BUNCH_MULTIPLIER;
 
+		if (!g_BarterSell)
+			g_BarterSell = g_ResourceData.GetCodes()[0];
+
 		amount.Sell.caption = "-" + amountToSell;
 		let prices = data.unitEntState.barterMarket.prices;
 		amount.Buy.caption = "+" + Math.round(prices.sell[g_BarterSell] / prices.buy[data.item] * amountToSell);
 
-		let resource = getLocalizedResourceName(data.item, "withinSentence");
+		let resource = getLocalizedResourceName(g_ResourceData.GetNames()[data.item], "firstWord");
 		button.Buy.tooltip = sprintf(translate("Buy %(resource)s"), { "resource": resource });
 		button.Sell.tooltip = sprintf(translate("Sell %(resource)s"), { "resource": resource });
 
@@ -164,8 +168,10 @@ g_SelectionPanels.Barter = {
 		button.Sell.hidden = false;
 		selectionIcon.hidden = !isSelected;
 
-		setPanelObjectPosition(button.Sell, data.i, data.rowLength);
-		setPanelObjectPosition(button.Buy, data.i + data.rowLength, data.rowLength);
+		let sellPos = data.i + (data.i >= data.rowLength ? data.rowLength : 0);
+		let buyPos = data.i + data.rowLength * (data.i >= data.rowLength ? 2 : 1);
+		setPanelObjectPosition(button.Sell, sellPos, data.rowLength);
+		setPanelObjectPosition(button.Buy, buyPos, data.rowLength);
 		return true;
 	}
 };
diff --git a/binaries/data/mods/public/gui/session/selection_panels_helpers.js b/binaries/data/mods/public/gui/session/selection_panels_helpers.js
index fc0e7a6..46976f9 100644
--- a/binaries/data/mods/public/gui/session/selection_panels_helpers.js
+++ b/binaries/data/mods/public/gui/session/selection_panels_helpers.js
@@ -1,18 +1,11 @@
 const BARTER_RESOURCE_AMOUNT_TO_SELL = 100;
 const BARTER_BUNCH_MULTIPLIER = 5;
-const BARTER_RESOURCES = ["food", "wood", "stone", "metal"];
 const BARTER_ACTIONS = ["Sell", "Buy"];
 const GATE_ACTIONS = ["lock", "unlock"];
 
-// upgrade constants
 const UPGRADING_NOT_STARTED = -2;
 const UPGRADING_CHOSEN_OTHER = -1;
 
-// ==============================================
-// BARTER HELPERS
-// Resources to sell on barter panel
-var g_BarterSell = "food";
-
 function canMoveSelectionIntoFormation(formationTemplate)
 {
 	if (!(formationTemplate in g_canMoveIntoFormation))
diff --git a/binaries/data/mods/public/gui/session/session.js b/binaries/data/mods/public/gui/session/session.js
index 35af7a7..af267cb 100644
--- a/binaries/data/mods/public/gui/session/session.js
+++ b/binaries/data/mods/public/gui/session/session.js
@@ -122,6 +122,7 @@ var g_EntityStates = {};
 var g_TemplateData = {};
 var g_TemplateDataWithoutLocalization = {};
 var g_TechnologyData = {};
+var g_ResourceData = new Resources();
 
 /**
  * Top coordinate of the research list.
@@ -463,10 +464,18 @@ function updateTopPanel()
 	let viewPlayer = Engine.GetGUIObjectByName("viewPlayer");
 	viewPlayer.hidden = !g_IsObserver && !g_DevSettings.changePerspective;
 
-	Engine.GetGUIObjectByName("food").hidden = !isPlayer;
-	Engine.GetGUIObjectByName("wood").hidden = !isPlayer;
-	Engine.GetGUIObjectByName("stone").hidden = !isPlayer;
-	Engine.GetGUIObjectByName("metal").hidden = !isPlayer;
+	let resCodes = g_ResourceData.GetCodes();
+	let resNames = g_ResourceData.GetNames();
+	let r = 0;
+	for (let res of resCodes)
+	{
+		Engine.GetGUIObjectByName("resource["+r+"]_icon").sprite = "stretched:session/icons/resources/" + res + ".png";
+		Engine.GetGUIObjectByName("resource["+r+"]").hidden = !isPlayer;
+		++r;
+	}
+	horizontallyDistributeObjects("resourceCounts", 0, r);
+	hideRemaining("resource[", r, "]");
+
 	Engine.GetGUIObjectByName("population").hidden = !isPlayer;
 	Engine.GetGUIObjectByName("diplomacyButton1").hidden = !isPlayer;
 	Engine.GetGUIObjectByName("tradeButton1").hidden = !isPlayer;
@@ -547,7 +556,8 @@ function leaveGame(willRejoin)
 			"disconnected": g_Disconnected,
 			"isReplay": g_IsReplay,
 			"replayDirectory": !g_HasRejoined && replayDirectory,
-			"replaySelectionData": g_ReplaySelectionData
+			"replaySelectionData": g_ReplaySelectionData,
+			"resources": GetSimState().resources
 		}
 	});
 }
@@ -947,14 +957,18 @@ function getAllyStatTooltip(resource)
 
 function updatePlayerDisplay()
 {
-	let playerState = GetSimState().players[g_ViewedPlayer];
+	let simState = GetSimState();
+	let playerState = simState.players[g_ViewedPlayer];
 	if (!playerState)
 		return;
 
-	for (let res of RESOURCES)
+	let resCodes = g_ResourceData.GetCodes();
+	let resNames = g_ResourceData.GetNames();
+	for (let r = 0; r < resCodes.length; ++r)
 	{
-		Engine.GetGUIObjectByName("resource_" + res).caption = Math.floor(playerState.resourceCounts[res]);
-		Engine.GetGUIObjectByName(res).tooltip = getLocalizedResourceName(res, "firstWord") + getAllyStatTooltip(res);
+		let res = resCodes[r];
+		Engine.GetGUIObjectByName("resource["+r+"]").tooltip = getLocalizedResourceName(resNames[res], "firstWord") + getAllyStatTooltip(res);
+		Engine.GetGUIObjectByName("resource["+r+"]_count").caption = Math.floor(playerState.resourceCounts[res]);
 	}
 
 	Engine.GetGUIObjectByName("resourcePop").caption = sprintf(translate("%(popCount)s/%(popLimit)s"), playerState);
diff --git a/binaries/data/mods/public/gui/structree/draw.js b/binaries/data/mods/public/gui/structree/draw.js
index 92c60ce..ee15fb3 100644
--- a/binaries/data/mods/public/gui/structree/draw.js
+++ b/binaries/data/mods/public/gui/structree/draw.js
@@ -235,18 +235,6 @@ function getPositionOffset(idx)
 	return size;
 }
 
-function hideRemaining(prefix, idx, suffix)
-{
-	let obj = Engine.GetGUIObjectByName(prefix + idx + suffix);
-	while (obj)
-	{
-		obj.hidden = true;
-		++idx;
-		obj = Engine.GetGUIObjectByName(prefix + idx + suffix);
-	}
-}
-
-
 /**
  * Positions certain elements that only need to be positioned once
  * (as <repeat> does not reposition automatically).
diff --git a/binaries/data/mods/public/gui/structree/load.js b/binaries/data/mods/public/gui/structree/load.js
index 534747b..006de1b 100644
--- a/binaries/data/mods/public/gui/structree/load.js
+++ b/binaries/data/mods/public/gui/structree/load.js
@@ -5,28 +5,24 @@
  */
 function getGatherRates(templateName)
 {
-	// TODO: It would be nice to use the gather rates present in the templates
-	// instead of hard-coding the possible rates here.
-
-	// We ignore ruins here, as those are not that common and would skew the results
-	var types = {
-		"food": ["food", "food.fish", "food.fruit", "food.grain", "food.meat", "food.milk"],
-		"wood": ["wood", "wood.tree"],
-		"stone": ["stone", "stone.rock"],
-		"metal": ["metal", "metal.ore"]
-	};
-	var rates = {};
+	let rates = {};
 
-	for (let type in types)
+	for (let resource of g_ResourceData.GetData())
 	{
+		let types = [resource.code];
+		for (let subtype of resource.subtypes)
+			// We ignore ruins as those are not that common and skew the results
+			if (subtype !== "ruins")
+				types.push(resource.code + "." + subtype);
+
 		let count, rate;
-		[rate, count] = types[type].reduce(function(sum, t) {
+		[rate, count] = types.reduce(function(sum, t) {
 				let r = +fetchValue(templateName, "ResourceGatherer/Rates/"+t);
 				return [sum[0] + (r > 0 ? r : 0), sum[1] + (r > 0 ? 1 : 0)];
 			}, [0, 0]);
 
 		if (rate > 0)
-			rates[type] = Math.round(rate / count * 100) / 100;
+			rates[resource.code] = Math.round(rate / count * 100) / 100;
 	}
 
 	if (!Object.keys(rates).length)
diff --git a/binaries/data/mods/public/gui/structree/structree.js b/binaries/data/mods/public/gui/structree/structree.js
index 65bfd9e..fcb6a9c 100644
--- a/binaries/data/mods/public/gui/structree/structree.js
+++ b/binaries/data/mods/public/gui/structree/structree.js
@@ -9,6 +9,7 @@ var g_Lists = {};
 var g_CivData = {};
 var g_SelectedCiv = "";
 var g_CallbackSet = false;
+var g_ResourceData = new Resources();
 
 /**
  * Initialize the dropdown containing all the available civs
diff --git a/binaries/data/mods/public/gui/summary/counters.js b/binaries/data/mods/public/gui/summary/counters.js
index 562e3bb..1823b67 100644
--- a/binaries/data/mods/public/gui/summary/counters.js
+++ b/binaries/data/mods/public/gui/summary/counters.js
@@ -250,7 +250,7 @@ function calculateUnits(playerState, position)
 
 function calculateResources(playerState, position)
 {
-	let type = g_ResourcesTypes[position];
+	let type = g_ResourceData.GetCodes()[position];
 
 	return formatIncome(
 		playerState.statistics.resourcesGathered[type],
@@ -262,7 +262,7 @@ function calculateTotalResources(playerState)
 	let totalGathered = 0;
 	let totalUsed = 0;
 
-	for (let type of g_ResourcesTypes)
+	for (let type of g_ResourceData.GetCodes())
 	{
 		totalGathered += playerState.statistics.resourcesGathered[type];
 		totalUsed += playerState.statistics.resourcesUsed[type] - playerState.statistics.resourcesSold[type];
@@ -330,7 +330,7 @@ function calculateResourcesTeam(counters)
 
 function calculateResourceExchanged(playerState, position)
 {
-	let type = g_ResourcesTypes[position];
+	let type = g_ResourceData.GetCodes()[position];
 
 	return formatIncome(
 		playerState.statistics.resourcesBought[type],
